=== debian/changelog ===
gvm-libs (22.4.1-2ubuntu1) lunar; urgency=medium

  * d/p/Fix-FTBFS-uninitialized-var-GCC-12.patch: Fix FTBFS due to
    uninitialized variable. (LP: #2002022)

 -- Sergio Durigan Junior <sergio.durigan@canonical.com>  Thu, 05 Jan 2023 13:35:58 -0500

gvm-libs (22.4.1-2) unstable; urgency=medium

  * Fix build on 32 bit arch

 -- Sophie Brun <sophie@offensive-security.com>  Wed, 28 Dec 2022 09:38:13 +0100

gvm-libs (22.4.1-1) unstable; urgency=medium

  [ Debian Janitor ]
  * Remove constraints unnecessary since buster

  [ Sophie Brun ]
  * New upstream version 22.4.1
  * Update debian/copyright
  * Add build-dep libpaho-mqtt-dev
  * Switch to libgvm22
  * Bump Standards-Version to 4.6.1 (no change)
  * Add a patch to build with libgpgme >= 1.18.0-2 (Closes: #1024489)
  * Fix debian/watch
  * New upstream version 22.4.1
  * Update symbols for 22.4.1

 -- Sophie Brun <sophie@offensive-security.com>  Wed, 21 Dec 2022 10:47:27 +0100
