## gvm-libs 22.4.2

=== CMakeLists.txt ===
--- 
+++ 
@@ -22,7 +22,7 @@
 
 # VERSION: Always include major, minor and patch level.
 project (gvm-libs
-  VERSION 22.4.1
+  VERSION 22.4.2
   LANGUAGES C)
 
 if (POLICY CMP0005)
