=== debian/changelog ===
gvm-libs (22.4.2-1) unstable; urgency=medium

  * New upstream version 22.4.2
  * Refresh patches

 -- Sophie Brun <sophie@offensive-security.com>  Fri, 27 Jan 2023 14:54:35 +0100
